<?php

/**
 * @file
 * Sets up the update test with the module at 2.0.0 configuration.
 */

use Drupal\Core\Database\Database;

$connection = Database::getConnection();

// Enable oembed_lazyload_youtube.
$extensions = $connection->select('config')
  ->fields('config', ['data'])
  ->condition('collection', '')
  ->condition('name', 'core.extension')
  ->execute()
  ->fetchField();

$extensions = unserialize($extensions, ['allowed_classes' => []]);
$extensions['module']['oembed_lazyload_youtube'] = 0;
$connection->update('config')
  ->fields(['data' => serialize($extensions)])
  ->condition('collection', '')
  ->condition('name', 'core.extension')
  ->execute();

// Nuke the configuration entirely.
$connection->delete('config')
  ->condition('name', 'oembed_lazyload_youtube.settings')
  ->execute();
