<?php

namespace Drupal\oembed_lazyload\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Settings form for the oembed lazyload module.
 */
class SettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['oembed_lazyload.settings'];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'oembed_lazyload_settings';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form['enable_resource_fetcher_overrides'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Enable advanced resource fetching controls'),
      '#default_value' => $this->config('oembed_lazyload.settings')->get('enable_resource_fetcher_overrides'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->config('oembed_lazyload.settings')
      ->set('enable_resource_fetcher_overrides', $form_state->getValue('enable_resource_fetcher_overrides'))
      ->save();
    parent::submitForm($form, $form_state);
  }

}
