<?php

namespace Drupal\oembed_lazyload;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceProviderBase;
use Drupal\oembed_lazyload\Oembed\OembedLazyloadResourceFetcher;
use Symfony\Component\DependencyInjection\Reference;

/**
 * Provides a customized oembed resource fetcher implementation.
 */
class OembedLazyloadServiceProvider extends ServiceProviderBase {

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container) {
    if ($container->hasDefinition('media.oembed.resource_fetcher')) {
      $definition = $container->getDefinition('media.oembed.resource_fetcher');

      // To avoid overriding the constructor, which isn't covered by B/C
      // guarantees, we can instead have the service container invoke setter
      // methods in order to provide the additional required services.
      $definition
        ->setClass(OembedLazyloadResourceFetcher::class)
        ->addMethodCall('setConfigFactory', [new Reference('config.factory')])
        ->addMethodCall('setProviderEnhancerManager', [new Reference('oembed_lazyload')]);
    }
  }

}
