<?php

namespace Drupal\Tests\oembed_lazyload\Kernel;

use Drupal\KernelTests\KernelTestBase;
use Drupal\oembed_lazyload\Oembed\OembedLazyloadResourceFetcher;

/**
 * Test cases pertaining to the service provider.
 *
 * @coversClass \Drupal\oembed_lazyload\OembedLazyloadServiceProvider
 *
 * @group oembed_lazyload
 */
class OEmbedLazyloadServiceProviderTest extends KernelTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'oembed_lazyload',
    'media',
  ];

  /**
   * Test case for confirming the service provider is functioning.
   *
   * @throws \ReflectionException
   */
  public function testServiceProvider() {
    $resource_fetcher = $this->container->get('media.oembed.resource_fetcher');

    static::assertInstanceOf(OembedLazyloadResourceFetcher::class, $resource_fetcher);

    // The service container should call various setters with the appropriate
    // references. This allows us to "safely" extend the core service without
    // fear of constructor arguments changing. Since the properties are
    // protected, we have to use reflection to inspect them in this test.
    foreach (['configFactory', 'providerEnhancerManager'] as $property) {
      $reflection_property = new \ReflectionProperty(
        OembedLazyloadResourceFetcher::class,
        $property
      );
      static::assertNotNull($reflection_property->getValue($resource_fetcher));
    }
  }

}
